/*
 * --- SDE-COPYRIGHT-NOTE-BEGIN ---
 * This copyright note is auto-generated by ./scripts/Create-CopyPatch.
 *
 * Filename: src/tools-source/versionsort.c
 * Copyright (C) 2009 The OpenSDE Project
 *
 * More information can be found in the files COPYING and README.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License. A copy of the
 * GNU General Public License can be found in the file COPYING.
 * --- SDE-COPYRIGHT-NOTE-END ---
 */

#include <string.h>
#include <ctype.h>
#include <stdio.h>

#include <stdlib.h>

static int cmp_version(const void *p0, const void *p1)
{
	const char *p, *q, *s0 = *(const char **)p0, *s1 = *(const char **)p1;
	unsigned int a = 0, b = 0;
	unsigned int ck0 = 1, ck1 = 1;

	while (ck0 || ck1) {
		a = b = 0;
		for (p = s0; *p != 0 && !isdigit(*p); p++) ;
		for (q = s1; *q != 0 && !isdigit(*q); q++) ;

		if (ck0) {
			for (s0 = p; isdigit(*s0); s0++) ;
			a = atoi(p);
		}
		if (ck1) {
			for (s1 = q; isdigit(*s1); s1++) ;
			b = atoi(q);
		}
		ck0 = ck0 && (*s0 == '.' || *s0 == '-');
		ck1 = ck1 && (*s1 == '.' || *s1 == '-');

		if (a != b)
			break;
		else if (ck0 && ck1 && *s0 != *s1) {
			a = ((*s0 == '.') << 1) | (*s0 == '-');
			b = ((*s1 == '.') << 1) | (*s1 == '-');
			break;
		} else if (ck0 ^ ck1) {
			a = ck0;
			b = ck1;
			break;
		}
		s0++;
		s1++;
	}

	return a - b;
}

int main(int argc, char **argv)
{
	register unsigned i;

	if (argc == 1 || strcmp(argv[1],"-?") == 0) {
		fprintf(stderr, "Usage: %s <s1> <s2> ..\n", argv[0]);
		return EXIT_FAILURE;
	}

	qsort(&argv[1], argc-1, sizeof(argv[0]), cmp_version);

	for (i=1; i<(unsigned)argc; i++)
		printf("%s\n", argv[i]);

	return EXIT_SUCCESS;
}
